; Program za pronalazenje min parnog broja, verzija 1
; Uvjeti: 	0x8100 - tu se nalazi adresa pocetka bloka
;		0x8104 - tu se nalazi duljina bloka
;		0x8108 - tu se nalazi rezultat (min. broj)

	AREA findmineven_v1, CODE, READWRITE
	
ADDR EQU 0x8100			; adresa pocetka bloka

	ENTRY

	MOV R8, #ADDR   	
	LDR R4, [R8], #4		; R4 = adresa pocetka bloka
	LDR R5, [R8], #4		; R5 = duljina bloka,
									; R8 = adresa rezultata
	CMP R5, #0
	BEQ KRAJ					; ako je duljina = 0 gotovo

	MVN R7, #0				; inicijalizacija min broja
	
PETLJA
	LDR R6, [R4], #4
	ANDS R9, R6, #1		; provjera je li broj paran
	BNE NASTAVAK  	 
	CMP R7, R6				; dosadasnji minimum veci od broja?
	MOVHS R7, R6			; DA: novi broj je novi min parni broj

NASTAVAK	
	SUBS R5, R5, #1
	BNE PETLJA
	STR R7, [R8]
KRAJ

	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
		
	END				


