; Program za pronalazenje max broja, verzija 1
; Parametri: 	0x8100 - tu se nalazi adresa pocetka bloka
;		0x8104 - tu se nalazi duljina bloka
;		0x8108 - tu se nalazi rezultat (max. broj)

	AREA findmax_v1, CODE, READWRITE
	
ADDR EQU 0x8100			; adresa parametara

	ENTRY

	MOV R8, #ADDR   	
	LDR R4, [R8], #4	; R4 = adresa pocetka bloka
	LDR R5, [R8], #4	; R5 = duljina bloka, R8 = adresa rezultata
	CMP R5, #0
	BEQ KRAJ		; ako je duljina = 0 gotovo

	MOV R7, #0		; inicijalizacija max broja
	
PETLJA
	LDR R6, [R4], #4
	CMP R6, R7
	MOVHI R7, R6
	SUBS R5, R5, #1
	BNE PETLJA
	STR R7, [R8]

KRAJ

	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI
		
	END


